<?php
include('login_mysql.php');

header ("Content-type: image/png");

$jour = date('Y-m-d');
if ( isset($_GET['date']) ) $jour = trim(htmlentities($_GET['date']));

$im = imagecreate(870, 400) or die ("Erreur lors de la création de l'image");        

// Couleurs
$couleur_fond = imagecolorallocate($im, 240, 240, 240);
$couleur_noir = imagecolorallocate($im, 0, 0, 0);
$couleur_gris = imagecolorallocate($im, 220, 220, 220);
$couleur_bleu = imagecolorallocate($im, 0, 0, 255);

// Titre
imagestring($im, 3, 340, 10, 'Puissance apparente ('.$jour.')', $couleur_noir);

// Lignes d'heures
for ( $ligne_heure = 0 ; $ligne_heure < 24 ; $ligne_heure++ ){
	
	if ( $ligne_heure == 0 ){
		imageline($im, 50, 30, 50, 390, $couleur_noir);
	}
	else{
		imageline($im, 50 + 30*$ligne_heure, 40, 50 + 30*$ligne_heure, 369, $couleur_gris);
		imagestring($im, 0, 48 + 30*$ligne_heure, 377, $ligne_heure, $couleur_noir);
	}
}
imagestring($im, 2, 800, 377, "Heures", $couleur_noir);

// Puissance max
$puissance_max = 1000;
$result = $connexion_sql->query('SELECT puissance_apparente FROM releve WHERE DATE(date_heure)="'.$jour.'" ORDER BY puissance_apparente DESC LIMIT 1');
foreach ($result as $row){
	$puissance_max = $row['puissance_apparente'];
}
$palier_max_puissance = 500;
while ( $palier_max_puissance < $puissance_max ){
	$palier_max_puissance = $palier_max_puissance + 500;
}


// Lignes de puissance
imageline($im, 30, 370, 780, 370, $couleur_noir);
$pixels_par_watt = 300 / $palier_max_puissance;
for ( $i = 500 ; $i <= $palier_max_puissance ; $i = $i + 500 ){
	$heuteur_pixel = floor(370 - $pixels_par_watt * $i);
	imageline($im, 50, $heuteur_pixel, 770, $heuteur_pixel, $couleur_gris);
	imageline($im, 47, $heuteur_pixel, 53, $heuteur_pixel, $couleur_noir);
	imagestring($im, 0, 20, $heuteur_pixel - 4, $i, $couleur_noir);
}
imagestring($im, 2, 15, 20, "Watts", $couleur_noir);

// Pointes de lignes
imageline($im, 50, 30, 47, 33, $couleur_noir);
imageline($im, 50, 30, 53, 33, $couleur_noir);
imageline($im, 780, 370, 777, 367, $couleur_noir);
imageline($im, 780, 370, 777, 373, $couleur_noir);

// Affichage du tracé
$derniere_puissance = -1;
$derniere_minute = -1;
$derniere_heure = -1;
$result = $connexion_sql->query('SELECT 
							HOUR(date_heure) AS heure, 
							MINUTE(date_heure) AS minute,
							puissance_apparente 
							FROM releve 
							WHERE DATE(date_heure)="'.$jour.'" 
							ORDER BY date_heure');
foreach ($result as $row){
	
	if ( $derniere_puissance != -1 ){
		$hauteur_derniere_puissance = floor(370 - $pixels_par_watt * $derniere_puissance);
		$largeur_dernier_temps = 50 + $derniere_heure * 30 + floor($derniere_minute / 2);
		
		$hauteur_puissance = floor(370 - $pixels_par_watt * $row['puissance_apparente']);
		$largeur_temps = 50 + $row['heure'] * 30 + floor($row['minute'] / 2);
		
		
		imageline($im, $largeur_dernier_temps, $hauteur_derniere_puissance, $largeur_temps, $hauteur_puissance, $couleur_bleu);
	}
	
	$derniere_puissance = $row['puissance_apparente'];
	$derniere_minute = $row['minute'];
	$derniere_heure = $row['heure'];
}

imagepng($im);
?>